From 8984995600655d86d8a0c524689132256ecd3d3f Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Aug 30 2020 01:35:31 +0000
Subject: [PATCH 730/2232] Box, Vec of an extern enum is supposed to work


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 22ae58e..7b84b18 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -71,7 +71,7 @@ fn check_type_ident(cx: &mut Check, ident: &Ident) {
 
 fn check_type_box(cx: &mut Check, ptr: &Ty1) {
     if let Type::Ident(ident) = &ptr.inner {
-        if cx.types.cxx.contains(ident) {
+        if cx.types.cxx.contains(ident) && !cx.types.enums.contains_key(ident) {
             cx.error(ptr, error::BOX_CXX_TYPE.msg);
         }
 
@@ -85,7 +85,7 @@ fn check_type_box(cx: &mut Check, ptr: &Ty1) {
 
 fn check_type_rust_vec(cx: &mut Check, ty: &Ty1) {
     if let Type::Ident(ident) = &ty.inner {
-        if cx.types.cxx.contains(ident) {
+        if cx.types.cxx.contains(ident) && !cx.types.enums.contains_key(ident) {
             cx.error(ty, "Rust Vec containing C++ type is not supported yet");
             return;
         }
@@ -320,7 +320,9 @@ fn is_unsized(cx: &mut Check, ty: &Type) -> bool {
         Type::CxxVector(_) | Type::Slice(_) | Type::Void(_) => return true,
         _ => return false,
     };
-    ident == CxxString || cx.types.cxx.contains(ident) || cx.types.rust.contains(ident)
+    ident == CxxString
+        || cx.types.cxx.contains(ident) && !cx.types.enums.contains_key(ident)
+        || cx.types.rust.contains(ident)
 }
 
 fn span_for_struct_error(strct: &Struct) -> TokenStream {

